from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import File, Boolean, Int

Maprttransformer_V0_1_0 = CommandToolBuilder(tool="MapRTTransformer", base_command=["MapRTTransformer"], inputs=[ToolInput(tag="in_in", input_type=File(optional=True), prefix="-in", doc=InputDocumentation(doc="Input file to transform (separated by blanks) (valid formats: 'mzML', 'featureXML', 'consensusXML', 'idXML')")), ToolInput(tag="in_out", input_type=File(optional=True), prefix="-out", doc=InputDocumentation(doc="Output file (same file type as 'in'). Either this option or 'trafo_out' has to be provided; they can be used together. (valid formats: 'mzML', 'featureXML', 'consensusXML', 'idXML')")), ToolInput(tag="in_traf_o_in", input_type=File(optional=True), prefix="-trafo_in", doc=InputDocumentation(doc="*    Transformation to apply (valid formats: 'trafoXML')")), ToolInput(tag="in_traf_o_out", input_type=File(optional=True), prefix="-trafo_out", doc=InputDocumentation(doc="Transformation output file. Either this option or 'out' has to be provided; they can be used together. (valid formats: 'trafoXML')")), ToolInput(tag="in_invert", input_type=Boolean(optional=True), prefix="-invert", doc=InputDocumentation(doc="Invert transformation (approximatively) before applying it")), ToolInput(tag="in_store_original_rt", input_type=File(optional=True), prefix="-store_original_rt", doc=InputDocumentation(doc="Store the original retention times (before transformation) as meta data in the output file")), ToolInput(tag="in_ini", input_type=File(optional=True), prefix="-ini", doc=InputDocumentation(doc="Use the given TOPP INI file")), ToolInput(tag="in_threads", input_type=Int(optional=True), prefix="-threads", doc=InputDocumentation(doc="Sets the number of threads allowed to be used by the TOPP tool (default: '1')")), ToolInput(tag="in_write_ini", input_type=File(optional=True), prefix="-write_ini", doc=InputDocumentation(doc="Writes the default configuration file")), ToolInput(tag="in_helphelp", input_type=Boolean(optional=True), prefix="--helphelp", doc=InputDocumentation(doc="Shows all options (including advanced)"))], outputs=[ToolOutput(tag="out_out", output_type=File(optional=True), selector=InputSelector(input_to_select="in_out", type_hint=File()), doc=OutputDocumentation(doc="Output file (same file type as 'in'). Either this option or 'trafo_out' has to be provided; they can be used together. (valid formats: 'mzML', 'featureXML', 'consensusXML', 'idXML')")), ToolOutput(tag="out_traf_o_out", output_type=File(optional=True), selector=InputSelector(input_to_select="in_traf_o_out", type_hint=File()), doc=OutputDocumentation(doc="Transformation output file. Either this option or 'out' has to be provided; they can be used together. (valid formats: 'trafoXML')")), ToolOutput(tag="out_store_original_rt", output_type=File(optional=True), selector=InputSelector(input_to_select="in_store_original_rt", type_hint=File()), doc=OutputDocumentation(doc="Store the original retention times (before transformation) as meta data in the output file"))], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Maprttransformer_V0_1_0().translate("wdl", allow_empty_container=True)

